	' Gestion de portail (Mag1 21 02 2013)
	' Gestion manuelle par poussoir commande sq : ouverture/arrt/fermeture/arrt/
	' Fermeture automatique temporise
	' Rouverture auto en cas d'obstacle par barrire IR
	' Rouverture auto en cas de surcharge moteur (seuil rglable)
	' Il y a deux programmes en temps partag
	' La commande est gre par interruption

	#picaxe 20M2 'directive spcification picaxe 20M2
	
start0: 'Premier programme en temps partag

'****** Nomination des ports entres **********************
	symbol cmd 		= pinC.5	'commande sur pin interruption 
	symbol fcf	 	= pinC.6	'fin de course fermeture
	symbol fco	 	= pinC.7	'fin de course ouverture	
	symbol sensib	= B.5		'pot lecture seuil sensibilit
	symbol courmot	= B.6		'lecture courant moteur
	symbol alert	= pinC.0	'lecture tat barrire IR
	symbol lecpot	= C.1		'ADC ou Fixe 1 = fermeture auto ; 0 = manuelle
	
'******* Nomination des ports sorties *******************	 
	symbol LedR		= B.0		'sortie flash	'
	symbol EmetIR	= B.1		'sortie Led IR
	symbol ouv		= B.2		'commande moteur ouverture
	symbol ferm		= B.3		'commande moteur fermeture	
	
'******* Nomination des variables ***************	
'******** Variables type bit (1 bit ) ************
	symbol mouv		= bit0	'bit tat "en mouvement" pour le flash 
	symbol souvre	= bit1	'mmo tat prcdent (1=ouverture; 0=fermeture)
	symbol obst		= bit2	'mmo dtection obstacle
	symbol fermauto	= bit3	'mmo fermauto ou manuel	
'******** Variables type byte (1 octet) ************** 
	symbol etat		= b1		'tat en cours 1=ouverture; 2=fermeture; 3= arret
	symbol seuil	= b2		'valeur seuil sensib
	symbol courant	= b3		'mesure du courant
'********* Variables type word (2 octets) ****************
	symbol tempo	= w13		'lecture temporisation
		
'**********************************************************
	'do:loop while cmd=0 		'attente pour rglage ADC sur simulateur
		
'******** Initialisation variables ********	
	low ouv: low ferm: low ledR	
	etat =3				'etat arret  la mise en route
	souvre=0				'memo fermeture la 1re commande sera ouverture

		
	pwmout EmetIR, 104, 211 'activation Emetteur IR PWM 38 kHz  16MHz
		
'******** Interruption sur C.5 niveau haut *********	 
	setint %00100000 ,%00100000	

'******** Boucle principale ********		
	Do
	
' **************** Rglage temporisation 	
		readadc10 lecpot,tempo	'lecture pot. tempo. Donne un nombre de 0  1023
		if tempo > 1000 then	'pot max, on passe en manuel ou pas de pot C.1  5 v
			fermauto=0		'fermauto =0 cd en manuel		
		elseif tempo <20 then	'automatic sans pot C.1 est  0
			fermauto=1		'fermauto =1 cd automatique 
			tempo=4000		'tempo fixe 4 s
		else 				'pot position mdiane
			fermauto=1		'donc automatique, avec
			tempo= 20*tempo	'rglage tempo 0,4s  20s
		endif
		
' ***************	Rglage sensibilit obstacle
		readadc sensib, seuil	'lecture du seuil	moteur
		
' ***************
	
		select  etat	'aiguillage suivant variable "etat= 1, 2, 3, 4"
		
		case 1 		' etat =1 = ouverture
			mouv=1	'pour le flash
			souvre=1	'mmo tat
			obst=0	'reset mmo obstacle IR
			
			do		'boucle ouverture
				low ferm : high ouv		'positionnement des relais ouverture				
			loop while fco=0 and etat=1		'tant que fco ouvert et pas de changementd'tat		
			if etat<>3 then				'si arret par commande, on y reste
				etat=4				'sinon etat fermeture auto temporis
			endif
					
		case 2 		' tat = 2 = fermeture		
			mouv=1	'pour le flash
			souvre=0	'mmo tat			
			do		'boucle fermeture
				readadc courmot, courant 	'lecture courant moteur
				if courant > seuil then		'si dpassemnt seuil
						obst=1		'mmo dtect obstacle 
						etat=1		'positionnement tat ouverture					
				endif
				
				if alert=1 then		'dtection alert IR
						etat=1	'position tat ouverture						 
				endif
				
				low ouv: high ferm	'on ferme!
			loop while fcf=0 and etat=2	'tant que fcf ouvert et pas de changement d'tat
			
			if alert=0 and obst =0	then	'pas de problmes ?					
					 etat =3		'alors,positionnement tat arret						
			endif								
		
		case 3		' tat =3 = arret ;flash OFF		
			low ouv : low ferm	'arret moteur		
			mouv=0			'arret du flash
			
		case 4		'tat = 4 = fermeture automatique ; flash ON
			low ouv : low ferm			'arret moteur		
			do						'boucle temporisation mini 1 fois
				pause tempo				'attente 
			loop while alert=1 and etat=4	' si obstable IR et pas changement tat, on boucle	
			if fermauto =1 and etat=4 then	'si automatique =1 et etat 4
				etat=2				'fermeture auto
						else			'sinon							
				etat=3				'arret
			endif						'fin de if
		end select						'fin de select
	loop								'fin de boncle principale

interrupt:	'Ah, on a appuy sur le bouton !!

	do : loop while cmd=1 'attente relachement poussoir
	
	select etat
	
		case 1,2,4		'on est en tat 1,2 ou 4	
			etat = 3		'alors passage  l'tat 3 (arret)
					
		case 3 		'on est  l'arret
			if souvre=1 then 	' tat prcdent= ouverure 
					etat=2	' alors on passe en fermeture
			else 
					etat=1	' sinon, c'est le contraire
			endif		
	end select
	
	setint %00100000 ,%00100000	'reset de l'interruption
	
	return	
' ***************************************************************************	
start1:	'Second programme en temps partag uniquement pour le flash

	Do
	if mouv=1 then	'si mouvement
		high ledR	'a 
		pause 500	'cli
		low ledR	'gno
		pause 500	'te !
	endif
	loop
		